#include "ac.h"
#include "no_deletion_stack.h"

//----------------------------
// constructor and destructor
//----------------------------

// constructor
AC::AC (Multiple_Residue_Support * ls, Constraint_Selection * cs, bool one_pass) {
	supports = ls;
	selection = cs;
	onepass = one_pass;	
}

// destructor
AC::~AC () {
	delete supports;
	delete selection;
}


//-----------------
// basic functions
//-----------------


// achieves the current AC algorithm on the CSP pb and returns true if the problem is consistent w.r.t. this algorithm, false otherwise 
bool AC::Achieve (CSP * pb) {
	Assignment A (pb->Get_N());
	Deletion_Stack * ds = new No_Deletion_Stack ();

  bool res = Achieve (pb,A,ds);
  delete ds;
  return res;
}
