#include "assignment.h"


//--------------
// constructors
//--------------

// construct an empty assignment and reserves memory for an assignment of  maximum size max_size
Assignment::Assignment (int max_size) : values (max_size), position (max_size,-1) {}


// construct an assignment by copying the assignment a
Assignment::Assignment (Assignment & a) {
	values = a.values;
	position = a.position;	
}


//----------
// operator
//----------


// operator =
Assignment & Assignment::operator= (Assignment & a) {
	if (this != &a) {
		values = a.values;
		position = a.position;
	}
	return *this;
}
	

//-----------------	
// basic functions
//-----------------


// unassignes the variable var in the current assignment
void Assignment::Unassign (int var) {
	for (unsigned int i = position[var]+1; i < values.size(); i++)	values[i-1] = values[i];
	values.pop();
	position[var] = -1;
}


// unassignes all the variables
void Assignment::Clear () {
	while (values.size() > 0) {
		position[values.top().first] = -1;
		values.pop();
	}
}
