#include "avl.h"


//-----------------------------
// constructors and destructor
//-----------------------------


// constructs an empty AVL for the tuples over the Cartesian products of the domains of the variables in var
AVL::AVL (vector<Variable *> & var) {
	root = 0;
	size = 0;
	arity = var.size();
	tuple_list = new AVL_Node ** [arity];
	for (int i = 0; i < arity; i++)	{
		tuple_list[i] = new AVL_Node * [var[i]->Get_Domain()->Get_Initial_Size()];
		for (unsigned int j = 0; j < var[i]->Get_Domain()->Get_Initial_Size(); j++)		tuple_list[i][j] = 0;
	}
}


// constructs an empty AVL for the tuples over the Cartesian products of the domains of the variables in var
AVL::AVL (Light_Vector<Variable *> & var) {
	root = 0;
	size = 0;
	arity = var.get_capacity();
	tuple_list = new AVL_Node ** [arity];
	for (int i = 0; i < arity; i++)	{
		tuple_list[i] = new AVL_Node * [var[i]->Get_Domain()->Get_Initial_Size()];
		for (unsigned int j = 0; j < var[i]->Get_Domain()->Get_Initial_Size(); j++)	 tuple_list[i][j] = 0;
	}
}


// constructs an empty AVL for the tuples over the Cartesian products of the domains of the variables in var
AVL::AVL (Light_Set<Variable *> & var) {
	root = 0;
	size = 0;
	arity = var.size();
	tuple_list = new AVL_Node ** [arity];
	for (int i = 0; i < arity; i++) {
		tuple_list[i] = new AVL_Node * [var[i]->Get_Domain()->Get_Initial_Size()];
		for (unsigned int j = 0; j < var[i]->Get_Domain()->Get_Initial_Size(); j++)		tuple_list[i][j] = 0;
	}
}


// destructor		
AVL::~AVL () {
	delete root;
	
	for (int i = 0; i < arity; i++)		delete [] tuple_list[i];
  
	delete [] tuple_list;
}
