#include "avl_iterator.h"


//--------------
// constructors
//--------------

// constructs an empty iterator
AVL_Iterator::AVL_Iterator () {
	object = 0;
	variable_pos = 0;
	current_pos = 0;
}


// constructs an iterator on the object o for which the current pos is set to initial_pos
AVL_Iterator::AVL_Iterator (AVL * o, int var_pos,AVL_Node * initial_pos) {
	object = o;
	variable_pos = var_pos;
	current_pos = initial_pos;
}


// constructs an iterator by copying the iterator iter
AVL_Iterator::AVL_Iterator (const AVL_Iterator & iter) {
	object = iter.object;
	variable_pos = iter.variable_pos;
	current_pos = iter.current_pos;
}


//-----------
// operators
//-----------


// operator =
AVL_Iterator & AVL_Iterator::operator= (const AVL_Iterator & iter) {
	if (this != &iter) {
		object = iter.object;
		variable_pos = iter.variable_pos;
		current_pos = iter.current_pos;
	}
	return *this;
}


// operator ++
AVL_Iterator & AVL_Iterator::operator++ (int)  {
	if (current_pos != 0)		current_pos = current_pos->Next_Tuple (variable_pos);

	return *this;
}
