#include "cluster_heuristic.h"


//-------------
// constructor 
//-------------


// constructs a cluster heuristic which can manege at most n candidates
Cluster_Heuristic::Cluster_Heuristic (int n) : candidates (n) {}



//----------------
// basic function
//----------------

// returns the number of the next cluster 
Cluster_Node * Cluster_Heuristic::Choose_Next_Cluster (Tree_Decomposition * td, CSP * pb, bool is_good[]) {
	Cluster_Node * c = 0;
	int min = pb->Get_N();
	
	for (Light_Set<Cluster_Node *>::iterator iter = candidates.begin(); iter != candidates.end(); iter++)
		if ((! is_good[(*iter)->Get_Num()]) && ((*iter)->Get_Separator()->Size() < min)) {
			min = (*iter)->Get_Separator()->Size();
			c = *iter;
		}
		
	return c;
}
