/// \file 
/// \brief Definitions related to the Constant_Element_Global_Constraint class

#ifndef CONSTANT_ELEMENT_GLOBAL_CONSTRAINT_H
#define CONSTANT_ELEMENT_GLOBAL_CONSTRAINT_H


#include "global_constraint.h"

class Constant_Element_Global_Constraint: public Global_Constraint  {    /// This class implements the element global constraint with constant value
  protected:
    int value;            ///< the constant value to which the constraint refers
    int * list_value;     ///< the number of the value corresponding to the constant value, for each variable of the scope
    
	public:
		// constructor and destructor
		Constant_Element_Global_Constraint (vector<Variable *> & var, int val);         ///< constructs a new element constraint with constant val which involves the variable in var
		~Constant_Element_Global_Constraint ();																					///< destructor
				
		// basic functions
		virtual bool Revise (CSP * pb, int var, Multiple_Residue_Support * ls, Deletion_Stack * ds);	 ///< returns true if the application of arc-consistency on the constraint w.r.t. the variable var deletes a value in the domain of var, false otherwise
};
#endif
