/// \file 
/// \brief Definitions related to the Constraint_Selection class

#ifndef CONSTRAINT_SELECTION_H
#define CONSTRAINT_SELECTION_H

#include "constraint.h"

class Constraint_Selection {     /// This class allows to select some constraints 
	public:	

		// basic function
		bool Is_Eligible (Constraint * c, int var);	 ///< returns true if the constraint num is eligible w.r.t. the variable x of the CSP pb, false otherwise
};


// returns true if the constraint num is eligible w.r.t. the variable x of the CSP pb, false otherwise
inline bool Constraint_Selection::Is_Eligible (Constraint * c, int var) {
	return c->Get_Unassigned_Variable_Number() != 0;
}

#endif

