/// \file 
/// \brief Definitions related to the Counter class

#ifndef COUNTER_H
#define COUNTER_H


template<class T>
class Counter {     /// This class implements generic counters
	protected:
		T value;				///< the current value of the counter

	public:	
		// constructor and destructor
		Counter ();    ///< constructs a null counter
	
		// operators
		Counter<T> & operator++ (int);			///< increases by one the value of the counter
		Counter<T> & operator-- (int);			///< decreases by one the value of the counter
	
		// basic functions
		void Reset ();														///< resets the counter to the value 0
		T Get_Value ();														///< returns the current value of	the counter
		void Set_Value (T val);										///< sets the value of the counter to the value val
		void Add (T val);													///< adds the value val to the counter
};


#include "counter.tpp"

#endif

