//----------------------------
// constructor and destructor
//----------------------------

// constructs a null counter
template<class T> Counter<T>::Counter () {
	value = 0;
}


//-----------
// operators
//-----------

// increases by one the value of the counter
template<class T> inline Counter<T> & Counter<T>::operator++ (int) {
	value++;
	return *this;
}


// decreases by one the value of the counter
template<class T> inline Counter<T> & Counter<T>::operator-- (int) {
	value--;
	return *this;
}


//-----------------
// basic functions
//-----------------

// resets the counter to the value 0
template<class T> inline void Counter<T>::Reset () {
	value = 0;
}


// returns the current value of	the counter
template<class T> inline T Counter<T>::Get_Value () {
	return value;
}


// sets the value of the counter to the value val
template<class T> inline void Counter<T>::Set_Value (T val) {
	value = val;
}


// adds the value val to the counter
template<class T> inline void Counter<T>::Add (T val){
	value += val;	
}
