/// \file 
/// \brief Definitions related to the Deletion_Stack class

#ifndef DELETION_STACK_H
#define DELETION_STACK_H

using namespace std;

#include "domain.h"

class Deletion_Stack {     /// This class allows to represent the stack of deletions in which the deletions of values are saved				
	public:	
		// destructor
		virtual ~Deletion_Stack(){};    ///< destructor
		
		// basic functions
		virtual void New_Level ()=0;												  ///< adds a new level of stack (i.e. increases the top of the stack)
		virtual void Add_Element (Domain * dom, int val)=0; 	///< adds an element (dom,val) to the current level of the stack 
		
    /// adds a tuple to the current level of the stack
    virtual void Add_Support (int num, int pos, int val, int arity, int * tuple) {};		
		virtual void Restore (CSP * pb)=0;									  ///< restores the elements at the top level and decreases the top of the stack
};

#endif
