#include "domain.h"


//--------------
// constructors
//--------------

// constructs an empty domain
Domain::Domain () {
	initial_size = 0;
	size = 0;
	ind_min = 0;
	ind_max = 0;
}


// constructs a domain by copying the domain d
Domain::Domain (Domain & d) {
	initial_size = d.initial_size;
	size = d.size;
	real_value = d.real_value;
	real_value_to_value = d.real_value_to_value;
	current_state = d.current_state;
	remaining_value = d.remaining_value;
	remaining_value_position = d.remaining_value_position;
	ind_min = d.ind_min;
	ind_max = d.ind_max;
	growing_ordering = d.growing_ordering;
	rev_growing_ordering = d.rev_growing_ordering;
}


//----------
// operator
//----------


// operator =
Domain & Domain::operator= (const Domain & d) {
	if (this != &d)	{
		initial_size = d.initial_size;
		size = d.size;
		real_value = d.real_value;
		real_value_to_value = d.real_value_to_value;
		current_state = d.current_state;
		remaining_value = d.remaining_value;
		remaining_value_position = d.remaining_value_position;
		ind_min = d.ind_min;
		ind_max = d.ind_max;
		growing_ordering = d.growing_ordering;
		rev_growing_ordering = d.rev_growing_ordering;
	}
	return *this;
}


//-----------------
// basic functions	
//-----------------


// adds a new value related to val in the domain
void Domain::Add_Value (int real_val) {
	real_value.expand (1);
	real_value[initial_size] = real_val;
	
	real_value_to_value.insert(make_pair(real_val,initial_size));
	
	current_state.expand (1);
	current_state[initial_size] = true;

	remaining_value.expand (1);
	remaining_value[initial_size] = initial_size;

	remaining_value_position.expand (1);
	remaining_value_position[initial_size] = initial_size;
	
	growing_ordering.expand (1);
	rev_growing_ordering.expand (1);
	
	if ((initial_size == 0) || (real_val > real_value[growing_ordering[initial_size-1]])) {
		growing_ordering[initial_size] = initial_size;
		rev_growing_ordering[initial_size] = initial_size;
		ind_max = initial_size;
	}
	else {
			int i = 0;
			while (real_val < real_value[growing_ordering[i]])  i++;
      
			for (int j = initial_size-1; j >= i; j--) {
				rev_growing_ordering[growing_ordering[j]] = j+1;
				growing_ordering[j+1] = growing_ordering[j];
			}
			growing_ordering[i] = initial_size;
			rev_growing_ordering[initial_size] = i;
			
			if (i == 0)		ind_min = 0;
		}
	
	initial_size++;
	size++;
}
