/// \file 
/// \brief Definitions related to the Element_Global_Constraint class

#ifndef ELEMENT_GLOBAL_CONSTRAINT_H
#define ELEMENT_GLOBAL_CONSTRAINT_H


#include "global_constraint.h"


class Element_Global_Constraint: public Global_Constraint {     /// This class implements the element global constraint with variable value
  protected:
    int ** list_value;     ///< the number of the value corresponding to the variable value, for each list variable of the scope and each value of the variable value
    
	public:
		// constructors and destructor
		Element_Global_Constraint (vector<Variable *> & var);         ///< constructs a new element constraint with the last variable in var as the variable value and which involves the variable in var
		~Element_Global_Constraint ();																///< destructor
				
		// basic functions
		virtual bool Revise (CSP * pb, int var, Multiple_Residue_Support * ls, Deletion_Stack * ds);	 ///< returns true if the application of arc-consistency on the constraint w.r.t. the variable var deletes a value in the domain of var, false otherwise
};
#endif
