/// \file 
/// \brief Definitions of counters

#ifndef GENERAL_COUNTERS_H
#define GENERAL_COUNTERS_H

#include "counter.h"
#include "timer.h"

#ifdef EXTERN
  // counters regarding the solving

  extern Timer Solving_Timer;                             // timer used for measuring the runtime of the solving step 
  extern Counter<unsigned long> Solving_Node_Counter;     // the number of nodes performed during the solving step 

#else

  Timer Solving_Timer;                          ///< timer used for measuring the runtime of the solving step 
  Counter<unsigned long> Solving_Node_Counter;  ///< the number of nodes performed during the solving step 
#endif

#endif
