/// \file 
/// \brief Definitions related to the Global_Constraint class

#ifndef GLOBAL_CONSTRAINT_H
#define GLOBAL_CONSTRAINT_H


#include "constraint.h"
#include "assignment.h"

class Global_Constraint: public Constraint  {    /// This class allows to represent global constraints
	public:
		// constructors and destructor
		Global_Constraint (vector<Variable *> & var);  ///< constructs a new global constraint with number n which involves the variable in var
				
		// basic functions
		virtual bool Revise (CSP * pb, int var, Multiple_Residue_Support * ls, Deletion_Stack * ds) = 0;	 ///< returns true if the application of arc-consistency on the constraint w.r.t. the variable var deletes a value in the domain of var, false otherwise
};

#endif
