/// \file 
/// \brief Definitions related to the Greater_Equal_Weighted_Sum_Arithmetic_Global_Constraint class

#ifndef GREATER_EQUAL_WEIGHTED_SUM_ARITHMETIC_GLOBAL_CONSTRAINT_H
#define GREATER_EQUAL_WEIGHTED_SUM_ARITHMETIC_GLOBAL_CONSTRAINT_H

#include "weighted_sum_arithmetic_global_constraint.h"


class Greater_Equal_Weighted_Sum_Arithmetic_Global_Constraint: public Weighted_Sum_Arithmetic_Global_Constraint {    /// This class implements the weighted sum global constraint with condition >=
	public:
		// constructors and destructor
		Greater_Equal_Weighted_Sum_Arithmetic_Global_Constraint (vector<Variable *> & var, vector<int> & w, int cst);						///< constructs a new constraint which involves the variable in var and whose relation compares the sum of the values of the variables in var weighted by weight from w to the constant cst with respect to >
		
		// basic functions
		virtual bool Revise (CSP * pb, int var, Multiple_Residue_Support * ls, Deletion_Stack * ds);	///< returns true if the application of arc-consistency on the constraint w.r.t. the variable var deletes a value in the domain of var, false otherwise
};

#endif
