/// \file 
/// \brief Definitions related to the In_Sum_Arithmetic_Global_Constraint class

#ifndef IN_SUM_ARITHMETIC_GLOBAL_CONSTRAINT_H
#define IN_SUM_ARITHMETIC_GLOBAL_CONSTRAINT_H

#include "sum_arithmetic_global_constraint.h"


class In_Sum_Arithmetic_Global_Constraint: public Sum_Arithmetic_Global_Constraint {   /// This class implements the sum global constraint with condition in
  protected:
    int constant2;      ///< the upper bound value of the interval
  
	public:
		// constructor
		In_Sum_Arithmetic_Global_Constraint (vector<Variable *> & var, int cst1, int cst2);		///< constructs a new constraint which involves the variable in var and which checks whether the sum of the values of the variables in var in the interval [cst1, cst2]
		
		// basic functions
		virtual bool Revise (CSP * pb, int var, Multiple_Residue_Support * ls, Deletion_Stack * ds);	 ///< returns true if the application of arc-consistency on the constraint w.r.t. the variable var deletes a value in the domain of var, false otherwise
};
#endif
