/// \file 
/// \brief Definitions related to the In_Weighted_Sum_Arithmetic_Global_Constraint class

#ifndef IN_WEIGHTED_SUM_ARITHMETIC_GLOBAL_CONSTRAINT_H
#define IN_WEIGHTED_SUM_ARITHMETIC_GLOBAL_CONSTRAINT_H

#include "weighted_sum_arithmetic_global_constraint.h"


class In_Weighted_Sum_Arithmetic_Global_Constraint: public Weighted_Sum_Arithmetic_Global_Constraint {   /// This class implements the weighted sum global constraint with condition in
  protected:
    int constant2;      ///< the upper bound value of the interval
  
	public:
		// constructors and destructor
		In_Weighted_Sum_Arithmetic_Global_Constraint (vector<Variable *> & var, vector<int> & w, int cst1, int cst2);	///< constructs a new constraint which involves the variable in var and which checks whether the weighted sum (weighted by weight from w) of the values of the variables in var in the interval [cst1, cst2]
		
		// basic functions
		virtual bool Revise (CSP * pb, int var, Multiple_Residue_Support * ls, Deletion_Stack * ds);	 ///< returns true if the application of arc-consistency on the constraint w.r.t. the variable var deletes a value in the domain of var, false otherwise
};

#endif
