#include "less_equal_sum_arithmetic_global_constraint.h"


//-------------
// constructor
//-------------


// constructs a new constraint which involves the variable in var and which checks whether the sum of the values of the variables in var is less than or equal to the constant cst
Less_Equal_Sum_Arithmetic_Global_Constraint::Less_Equal_Sum_Arithmetic_Global_Constraint (vector<Variable *> & var, int cst): 
           Sum_Arithmetic_Global_Constraint (var,cst) {}



//-----------------
// basic functions
//-----------------


// returns true if the application of arc-consistency on the constraint w.r.t. the variable var deletes a value in the domain of var, false otherwise
bool Less_Equal_Sum_Arithmetic_Global_Constraint::Revise (CSP * pb, int var, Multiple_Residue_Support * ls, Deletion_Stack * ds) {
	int sum = 0;
	Domain * dy;

	for (unsigned int i = 0; i < arity; i++)
		if (scope_var[i]->Get_Num() != var) {
			dy = scope_var [i]->Get_Domain();
			sum += dy->Get_Real_Value (dy->Get_Min());
		}

  int x = Get_Position (var);
	Domain * dx = scope_var [x]->Get_Domain();
	
	bool modif = false;
	int v;
	
	v = dx->Get_Max();
	
	while ((v != -1) && (sum + dx->Get_Real_Value(v) > constant)) {
		ds->Add_Element (dx,v);
		dx->Filter_Value (v);
			
		modif = true;

		v = dx->Previous_Value(v);
	}
	
	if (dx->Get_Size () == 0)  weight++;
	
  return modif;
}
