#include "max_weight_sum_root_heuristic.h"

//----------------
// basic function
//----------------


// chooses a root cluster which maximizes the sum of the weights of the contraint whose scope intersects the cluster
int Max_Weight_Sum_Root_Heuristic::Choose_Root (Cluster_Tree * ct, CSP * pb) {
	unsigned long max_sum = 0;
	int max_sum_num = -1;
	Multi_Hypergraph * h = pb->Get_Structure();
	unsigned long sum;
	
	for (map<int,Cluster_Node *>::iterator iter_cl = ct->Begin_List (); iter_cl != ct->End_List(); iter_cl++) {
		Light_Vector<vertex>::iterator iter;
		Light_List<Edge *>::iterator iter2;
		set<vertex>::iterator iter3;
		sum = 0;
		
		for (iter = iter_cl->second->begin(); iter != iter_cl->second->end(); iter++)
			for (iter2 = h->Begin_Edge_List(*iter); iter2 != h->End_Edge_List(*iter); iter2++) {
				// we look for the first vertex in the edge which also belongs to elements
				iter3 = (*iter2)->Begin();
				while ((iter3 != (*iter2)->End()) && (! iter_cl->second->Is_Element(*iter3)))		iter3++;
				
				if (*iter3 == *iter)	sum += pb->Get_Constraint((*iter2)->Get_Num())->Get_Weight();
			}
		
		if (max_sum < sum) {
			max_sum = sum;
			max_sum_num = iter_cl->first;
		}
	}
	
	return max_sum_num;
}
