#include "multiple_residue_support.h"
#include "csp.h"


//---------------------------
// constuctor and destructor
//---------------------------

// constructs an empty support for each variable x for each value v w.r.t. each constraint num
Multiple_Residue_Support::Multiple_Residue_Support (CSP * pb_init) {
	pb = pb_init;
	m = pb->Get_M();
	support = new int *** [m];
	int arity,pos;
	Constraint * C;
	
	for (unsigned int num = 0; num < m; num++) {
		C = pb->Get_Constraint (num);
		
    arity = C->Get_Arity();
    support[num] = new int ** [arity];
    
    for (pos = 0; pos < arity; pos++) {
      support[num][pos] = new int * [C->Get_Scope_Variable(pos)->Get_Domain()->Get_Initial_Size()];
      for (unsigned int v = 0; v < C->Get_Scope_Variable(pos)->Get_Domain()->Get_Initial_Size(); v++)
        support[num][pos][v] = 0;
    }
	}
}


// destructor
Multiple_Residue_Support::~Multiple_Residue_Support () {
 	int arity, pos;
	Constraint * C;
	
	for (unsigned int num = 0; num < m; num++) {
		C = pb->Get_Constraint (num);
		
    arity = C->Get_Arity();
  
    for (pos = 0; pos < arity; pos++) {
      for (unsigned int v = 0; v < C->Get_Scope_Variable(pos)->Get_Domain()->Get_Initial_Size(); v++)
        delete [] support[num][pos][v];
      delete [] support[num][pos];
    }
    delete [] support[num];
	}
	delete [] support;
}
