/// \file 
/// \brief Definitions related to the Negative_Nary_Extension_Constraint class

#ifndef NEGATIVE_NARY_EXTENSION_CONSTRAINT_H
#define NEGATIVE_NARY_EXTENSION_CONSTRAINT_H

#include "nary_extension_constraint.h"

class Positive_Nary_Extension_Constraint;

class Negative_Nary_Extension_Constraint: public Nary_Extension_Constraint {     /// This class implements n-ary constraints in extension with list of forbidden tuples

	public:
		// constructors and destructor
		Negative_Nary_Extension_Constraint (vector<Variable *> & var);			 					///< constructs a new constraint which involves the variable in var whose all the tuples are allowed
	

		// basic functions
		void Merge (Negative_Nary_Extension_Constraint * c);	///< merges the current constraint with the constraint c
		void Forbid_Tuple (int * t); 				 	 		 					  ///< forbids the tuple t
		virtual bool Revise (CSP * pb, int var, Multiple_Residue_Support * ls, Deletion_Stack * ds);	 ///< returns true if the application of arc-consistency on the constraint w.r.t. the variable var deletes a value in the domain of var, false otherwise
};

#endif
