/// \file 
/// \brief Definitions related to the No_Deletion_Stack class

#ifndef NO_DELETION_STACK_H
#define NO_DELETION_STACK_H

using namespace std;

#include "deletion_stack.h"
#include "csp.h"

class No_Deletion_Stack: public Deletion_Stack {   /// This class implements the absence of stack of deletions
	public:
		// basic functions
		virtual void New_Level (){};												///< adds a new level of stack (i.e. increases the top of the stack)
		virtual void Add_Element (Domain * dom, int val) {};	///< adds an element (dom,val) to the current level of the stack 
		virtual void Restore (CSP * pb) {};									///< restores the elements at the top level and decreases the top of the stack
};

#endif
