#include "restart_policy.h"

//-------------
// constructor
//-------------

// creates an new policy with limit lim and scaling factor sc_factor
Restart_Policy::Restart_Policy (unsigned long lim, double sc_factor) {
	limit = lim;
	backtrack_number_since_last_restart = 0;
	scaling_factor = sc_factor;
}


//-----------------
// basic functions
//-----------------


// returns true if the solver has to restart according to the given policy and reset all information required by the policy, false otherwise
bool Restart_Policy::Restart () {
	backtrack_number_since_last_restart++;

	if (limit == 	backtrack_number_since_last_restart)	{
		limit *= scaling_factor;
		backtrack_number_since_last_restart = 0;
		return true;
	}
	else return false;
}
