/// \file 
/// \brief Definitions related to the Sum_Arithmetic_Global_Constraint class

#ifndef SUM_ARITHMETIC_GLOBAL_CONSTRAINT_H
#define SUM_ARITHMETIC_GLOBAL_CONSTRAINT_H

#include "global_constraint.h"


class Sum_Arithmetic_Global_Constraint: public Global_Constraint {  /// This class allows to represent sum global constraints
	protected:
		int constant;						///< the constant to which the sum is compared
	
	public:
		// constructor
		Sum_Arithmetic_Global_Constraint (vector<Variable *> & var, int cst);	    	///< constructs a new constraint which involves the variable in var and whose relation compares the sum of the values of the variables in var to the constant cst with respect to comp
};
#endif
