/// \file 
/// \brief Definitions related to the Variable class

#ifndef VARIABLE_H
#define VARIABLE_H

#include "domain.h"
#include <string>

using namespace std;

class Variable {       /// This class allows to represent variables
	protected :
		int num;  		 		///< the number of the variable
		string name;      ///< the name of the variable
		Domain * domain;	///< the domain related to the variable
		
	public :
		// constructors and destructor
		Variable (int n=0, string ch="", Domain * d=0);	///< constructs an enumerated variable with the number n, the name ch and the domain d
		Variable (Variable & v);												///< constructs an enumerated variable by copying the variable v
		~Variable();			 															///< destructor
			
		// operator
		Variable & operator= (Variable & v);		///< operator =
			
		// basic functions	
		int Get_Num ();							 	  ///< returns the number of the variable
		string Get_Name ();        	    ///< returns the name of the variable
		Domain * Get_Domain ();    	    ///< returns the domain related to the variable
		void Set_Num (int n);    			 	///< sets the number of the variable to n
};



//-----------------------------
// inline function definitions
//-----------------------------


// returns the number of the variable
inline int Variable::Get_Num () {
	return num;
}


// returns the name of the variable
inline string Variable::Get_Name () {
	return name;
}


// returns the domain related to the variable
inline Domain * Variable::Get_Domain () {
	return domain;
}


// sets the number of the variable to n
inline void Variable::Set_Num (int n) {
	num = n;
}

#endif
