#include "weighted_sum_arithmetic_global_constraint.h"


//-----------------------------
// constructors and destructor
//-----------------------------


// constructs a new constraint which involves the variable in var and whose relation compares the sum of the values of the variables in var weighted by weight from w to the constant cst with respect to comp
Weighted_Sum_Arithmetic_Global_Constraint::Weighted_Sum_Arithmetic_Global_Constraint (vector<Variable *> & var, vector<int> & w, int cst): 
  Global_Constraint (var) {	
	weights = new int [arity];
		
	for (unsigned int i = 0; i < arity; i++)	weights[i] = w[i];
	
	constant = cst;
}


// destructor
Weighted_Sum_Arithmetic_Global_Constraint::~Weighted_Sum_Arithmetic_Global_Constraint () {
	delete [] weights;
}
