/// \file 
/// \brief Definitions related to the Weighted_Sum_Arithmetic_Global_Constraint class

#ifndef WEIGHTED_SUM_ARITHMETIC_GLOBAL_CONSTRAINT_H
#define WEIGHTED_SUM_ARITHMETIC_GLOBAL_CONSTRAINT_H

#include "global_constraint.h"


class Weighted_Sum_Arithmetic_Global_Constraint: public Global_Constraint {   /// This class allows to represent weighted sum global constraints

	protected:
		int constant;						///< the constant to which the sum is compared
		int * weights;			    ///< the weights associated to each variable
		
	public:
		// constructors and destructor
		Weighted_Sum_Arithmetic_Global_Constraint (vector<Variable *> & var, vector<int> & w, int cst);	///< constructs a new constraint which involves the variable in var and whose relation compares the sum of the values of the variables in var weighted by weight from w to the constant cst with respect to comp
		~Weighted_Sum_Arithmetic_Global_Constraint ();													 			   								///< destructor
};

#endif
