#include "child_node.h"


//-----------------------------
// constructors and destructor
//-----------------------------


// constructs an empty child node related to the graphical structure gs
Child_Node::Child_Node (Graphical_Structure * gs) : Vertex_Set (gs) {
	cluster_num = -1;
	cluster = 0;
}


// constructs a vertex set containing the vertices of element_set and related to the graphical structure gs
Child_Node::Child_Node (Light_Vector<vertex> element_set, Graphical_Structure * gs) : Vertex_Set (element_set,gs) {
	cluster_num = -1;
	cluster = 0;
}


// constructs a child node by copying the child node cn
Child_Node::Child_Node (Child_Node & cn) : Vertex_Set (cn) {
	cluster_num = cn.cluster_num;
	cluster =  cn.cluster;
}


//----------
// operator
//----------

// operator =
Child_Node & Child_Node::operator= (const Child_Node & cn) {
  if (this != &cn) {
		g = cn.g;
		size = cn.size;
		elements = cn.elements;
		is_element = cn.is_element;
		nb_edges = cn.nb_edges;
		nb_components = cn.nb_components;
		cluster_num = cn.cluster_num;
	}
	return *this;
}
