#include "edge.h"

//-----------------------------
// constructors and destructor
//-----------------------------


// constructs an edge whose number is num_edge and which involves the vertices from the array elements
Edge::Edge (int num_edge, vertex elements[], int arity){
	num = num_edge;
	
	for (int i = 0;	i < arity; i++)		scope.insert (elements[i]);
}


// constructs an edge by copying the edge e
Edge::Edge (Edge & e) {
	num = e.num;
	scope = e.scope;
}
		

//----------
// operator
//----------

// operator =
Edge & Edge::operator= (const Edge & e) {
	if (this != &e)	{
		num = e.num;
		scope = e.scope;
	}
	return * this;	
}


// operator ==
bool Edge::operator== (const Edge & e) {
	return scope == e.scope;
}


//-----------------------------------------
// basic operations or functions on graphs
//-----------------------------------------


// returns the nth vertex of the scope
vertex Edge::Get_Element (int n) {
	if ((n >= 0) && ((unsigned int) n <= scope.size()))	{
		set<vertex>::iterator iter;
		int i = 0;
		for (iter = scope.begin(); i < n; iter++)		i++;
		return *iter;
	}
	else return -1;
}
