/// \file 
/// \brief Definitions related to the First_Cluster_Heuristic class

#ifndef FIRST_CLUSTER_HEURISTIC_H
#define FIRST_CLUSTER_HEURISTIC_H

#include "cluster_node.h"
#include <climits>

class First_Cluster_Heuristic {        /// This class allows to represent heuristics for choosing the first cluster when computing tree-decompositions by heuristic methods
	protected:
		Graphical_Structure * g;          ///< the graphical structure we want to decompose
    int k;     ///< the maximal size allowed for a separator
		
	public:
    First_Cluster_Heuristic (Graphical_Structure * gs, int sep = INT_MAX);	  ///< constructs a heuristic which chooses a clique (of the primal graph of the graphical structure gs)											
		
    // basic function
		Cluster_Node * Choose (bool is_available[]);			///< returns the first cluster for a tree-decomposition according to a heuristic method. This cluster must be connected and its vertices must be chosen among the vertices for which the flag is_available is set to true
};

#endif

