//--------------
// constructors
//--------------


// constructs an empty iterator
template <class T> Light_Iterator<T>::Light_Iterator (){
	object = 0;
	current_pos = 0;
}


// constructs an iterator on the object o for which the current pos is set to initial_pos
template <class T> Light_Iterator<T>::Light_Iterator (Light_Vector<T> * o, int initial_pos){
	object = o;
	current_pos = initial_pos;
}

// constructs an iterator by copying the iterator iter
template <class T> Light_Iterator<T>::Light_Iterator (const Light_Iterator & iter){
	object = iter.object;
	current_pos = iter.current_pos;
}


//-----------
// operators
//-----------


// operator =
template <class T> inline Light_Iterator<T> & Light_Iterator<T>::operator= (const Light_Iterator<T> & iter){
	if (this != &iter)	{
		object = iter.object;
		current_pos = iter.current_pos;
	}
	return *this;
}


// operator ++
template <class T> inline Light_Iterator<T> & Light_Iterator<T>::operator++ (int){
	current_pos++;
	return *this;
}


// operator *
template <class T> inline T & Light_Iterator<T>::operator* (){
	return (*object)[current_pos];
}


// operator ==
template <class T> inline bool Light_Iterator<T>::operator== (const Light_Iterator<T> & iter){
	return ((object == iter.object) && (current_pos == iter.current_pos));
}

// operator !=
template <class T> inline bool Light_Iterator<T>::operator!= (const Light_Iterator<T> & iter){
	return ((object != iter.object) || (current_pos != iter.current_pos));
}
