//--------------
// constructors
//--------------

// constructs an empty iterator
template <class T> Light_List_Iterator<T>::Light_List_Iterator () {
	object = 0;
	current_pos = 0;
	prec_pos = 0;
}


// constructs an iterator on the object o for which the current position is set to the first node of the list if at_begin is true, to 0 otherwise
template <class T> Light_List_Iterator<T>::Light_List_Iterator (Light_List<T> * o, bool at_begin) {
	object = o;
	if (at_begin)	{
		current_pos = o->first;
		prec_pos = 0;
	}
	else {
			current_pos = 0;
			prec_pos = o->last;
		}
}


// constructs an iterator by copying the iterator iter
template <class T> Light_List_Iterator<T>::Light_List_Iterator (const Light_List_Iterator<T> & iter) {
	object = iter.object;
	current_pos = iter.current_pos;
	prec_pos = iter.prec_pos;
}


//-----------		
// operators
//-----------

// operator =
template <class T> inline Light_List_Iterator<T> & Light_List_Iterator<T>::operator= (const Light_List_Iterator<T> & iter) {
	if (this != &iter) {
		object = iter.object;
		current_pos = iter.current_pos;
		prec_pos = iter.prec_pos;
	}
	return *this;	
}


// operator ++
template <class T> inline Light_List_Iterator<T> & Light_List_Iterator<T>::operator++ (int) {
	if (current_pos != 0)	{
		prec_pos = current_pos;
		current_pos =	current_pos->next;
	}
	return *this;
}


// operator *
template <class T> inline T & Light_List_Iterator<T>::operator* () {
	if (current_pos != 0)	return current_pos->value;
	else throw ("Error: no possible value for the iterator");
}


// operator ==
template <class T> inline bool Light_List_Iterator<T>::operator== (const Light_List_Iterator<T> & iter) {
	return ((object == iter.object) && (current_pos == iter.current_pos));
}


// operator !=
template <class T> inline bool Light_List_Iterator<T>::operator!= (const Light_List_Iterator<T> & iter) {
	return ((object != iter.object) || (current_pos != iter.current_pos));
}
