//--------------
// constructors
//--------------

// constructs an empty set
template <class T> Light_Set<T>::Light_Set () {
	card = 0;
}


// constructs an empty set with at most n elements
template <class T> Light_Set<T>::Light_Set (int n) : Light_Vector<T> (n) {
	card = 0;
}


//----------
// operator
//----------


// operator =
template <class T> Light_Set<T> & Light_Set<T>::operator= (const Light_Set<T> & s) {
	if (this != &s)	{
		if (Light_Vector<T>::capacity != s.capacity) {
			delete [] (Light_Vector<T>::data);
			Light_Vector<T>::capacity = s.capacity;
			Light_Vector<T>::data = new T [Light_Vector<T>::capacity];
		}
		
		card = s.card;	
		for (unsigned int i = 0; i < card; i++)  Light_Vector<T>::data[i] = s.data[i];
	}
	return *this;
}


//-----------
// iterators
//-----------

// returns an iterator referring to the first element of the set
template <class T> inline Light_Iterator<T> Light_Set<T>::begin() {
	return Light_Iterator<T> (this);
}


// returns an iterator referring to the position after the last element of the set
template <class T> inline Light_Iterator<T> Light_Set<T>::end() {
	return Light_Iterator<T> (this,card);
}


//-----------------		
// basic functions
//-----------------


// returns the cardinality of the set
template <class T>inline unsigned int Light_Set<T>::size () {
	return card;
}


// adds the value val to the set
template <class T> inline void Light_Set<T>::add (T val) {
	Light_Vector<T>::data[card] = val;
	card++;
}


// removes the value val from the set
template <class T> void Light_Set<T>::remove (T val) {
	unsigned int i = 0;
	Light_Vector<T>::data[card] = val;
	while (Light_Vector<T>::data[i] != val)  i++;
  
	if (i < card)	{
		T tmp;
		tmp = Light_Vector<T>::data[i];
		Light_Vector<T>::data[i] = Light_Vector<T>::data[card-1];
		Light_Vector<T>::data[card-1] = tmp;
		card--;
	}
}


// removes the value val selected by the iterator iter
template <class T> inline void Light_Set<T>::remove (Light_Set<T>::iterator iter) {
	T tmp;
	tmp = *iter;
	*iter = Light_Vector<T>::data[card-1];
	Light_Vector<T>::data[card-1] = tmp;
	card--;
}


// returns true if the set is empty, false otherwise
template <class T> inline bool Light_Set<T>::is_empty () {
	return card == 0;
}


// removes all the elements of the set
template <class T> inline void Light_Set<T>:: clear () {
	card = 0;
}
