//--------------
// constructors
//--------------

// constructs an empty stack
template <class T> Light_Stack<T>::Light_Stack (){
	top_index = -1;
}


// constructs an empty stack with at most n elements
template <class T> Light_Stack<T>::Light_Stack (int n) : Light_Vector<T> (n) {
	top_index = -1;
}


		
//-----------------
// basic functions
//-----------------


// returns the size of stack
template <class T> inline unsigned int Light_Stack<T>::size () {
	return top_index+1;
}


// returns the element at the top of the stack
template <class T> inline T Light_Stack<T>::top () {
	return Light_Stack::data[top_index];
}


// pushes the element value in the stack
template <class T> inline void Light_Stack<T>::push (T value) {
	top_index++;
	Light_Stack::data[top_index] = value;
}


// removes the element at the top of the stack
template <class T> inline void Light_Stack<T>::pop () {
	top_index--;
}


// returns true if the stack is empty, false otherwise
template <class T> inline bool Light_Stack<T>::is_empty () {
	return top_index == -1;
}


// removes all the elements of the stack
template <class T> inline void Light_Stack<T>::clear () {
	top_index = -1;
}
